/* vim:set ts=2 sw=2 sts=2 expandtab */
/*jshint asi: true undef: true es5: true node: true devel: true
         forin: true latedef: false browser: true */
/*global define: true port: true */
!(typeof define === "undefined" ? function ($) { $(require, exports, module); } : define)(function (require, exports, module, undefined) {

"use strict";

var KEYS = 0
var VALUES = 1

function pairs(map) { return map(pairs) }

function add(key, keys) {
  if (~keys.indexOf(key)) throw Error("Duplicate key: " + key)
  keys.push(key)
}

function pair(elements, keys, values, index) {
  if (index >= elements.length) return [ keys, values ]

  var key = elements[index++], value = elements[index++]

  add(key, keys)
  values.push(value)

  return pair(elements, keys, values, index)
}

function Map(keyValues) {
  var keys = keyValues[KEYS], values = keyValues[VALUES]
  return function map(key) {
    return key === pairs ? keyValues : values[keys.indexOf(key)]
  }
}

exports.map = function map() {
  return Map(pair(arguments, [], [], 0))
}

// Remove elements from the map.
exports.remove = function remove(map) {
  var keyValues = pairs(map), keys = keyValues[KEYS], values = keyValues[VALUES]
  Array.prototype.slice.call(arguments, 1).forEach(function(target, index) {
    if (~(index = keys.indexOf(target))) {
      keys.splice(index, 1)
      values.splice(index, 1)
    }
  })
}

exports.clean = function clean(map) {
  var keyValues = paris(map)
  keyValues[KEYS].splice(0)
  keyValues[VALUES].splice(0)
}

// Merge multiple maps into one.
exports.merge = function merge() {
  var keys = [], values = []
  Array.prototype.map.call(arguments, pairs).forEach(function(keyValues) {
    keyValues[KEYS].forEach(function(key) {
      add(key, keys)
    })
    keyValues[VALUES].forEach(function(value) {
      values.push(value)
    })
  })
  return Map([ keys, values ])
}

});
